var vm = null,
    wx = null
function init() {
  wx = api.require('wx')
  // api.addEventListener({
  //     name:'viewdisappear'
  // }, function(ret, err){
  //   vm.$data.form.oauthCode = ''
  //   api.closeWin()
  // })
}
apiready = function() {
    init()
    vm = new Vue({
        el: '#vm',
        data: {
          form: {
            mobile: '',
            verify_code: '',
            oauthCode: ''
          },
          getverifyCodeText: '获取验证码',
          verifyCodeTime: 0,
          isNewUser: false
        },
        computed: {
          codeBg: function(){
            return DgValidator.isMobile(this.form.mobile) && (this.verifyCodeTime <= 0)
          },
          loginBg: function(){
            return DgValidator.isVerifyCode(this.form.verify_code)
          }
        },
        methods: {
          handlerAgreement: function(){
            api.openWin({
                name: 'login/agreement/agreement',
                url: './agreement/agreement.html',
                bounces: false,
                animation: {
                  type: 'movein',
                  duration: 300
                }
            })
          },
          handlerInstalled: function(){
            var _this = this
            wx.isInstalled(function(ret, err) {
              ret.installed ? _this.wxCode() : api.toast({msg: '手机还没有安装微信客户端'})
            })
          },
          wxCode: function(){
            var _this = this
            wx.auth({}, function(ret, err) {
              if (ret.status) {
                  _this.form.oauthCode = ret.code
                  _this.handlerLogin('wxAuth')
              }
            })
          },
          handlerClose: function(){
            var backData = util.getPrefs('backData')
            if(backData){
              api.openWin({
                  name: backData.name,
                  url: backData.url,
                  pageParam: backData.pageParam,
                  reload: true,
                  bounces: false
              })
            }else{
              api.closeWin()
            }
            this.form.oauthCode = ''
          },
          countDown: function(){
            this.verifyCodeTime--
            this.getverifyCodeText = this.verifyCodeTime + 's秒后重新获取'
            if(this.verifyCodeTime > 0){
              setTimeout(this.countDown, 1000)
            }else{
              this.getverifyCodeText = '重新获取'
            }

          },
          handlerCode: function(){
            if(this.verifyCodeTime > 0) return
            if(!DgValidator.isMobile(this.form.mobile)) return api.toast({msg: '请输入正确的手机号码'})
            var _this = this,
                utl = 'common/verify-code'
            var ajaxPromise = util.ajaxPromise({
                  url: utl,
                  method: 'post',
                  values: {
                    mobile: _this.form.mobile,
                    mobile_rule: 'mobile_required',
                    access_token: _this.form.mobile
                  }
                })
                ajaxPromise.then(function(ret){
                  if(ret.success){
                    _this.verifyCodeTime = 60
                    _this.countDown()
                  }
                  api.toast({msg: ret.message})
                }).fail(function(err){
                  api.toast({msg: msg.message})
                })
          },
          handlerLogin: function(type, url){
            var _this = this,
                url = 'auth/token',
                values = null
            if(type != 'wxAuth'){
              if(!DgValidator.isMobile(this.form.mobile)) return api.toast({msg: '请输入正确的手机号码'})
              if(!DgValidator.isVerifyCode(this.form.verify_code)) return api.toast({msg: '验证码4~6位'})
               values = {
                  mobile: _this.form.mobile,
                  verify_code: _this.form.verify_code,
                  access_token: _this.form.mobile,
                  oauth_code: _this.form.oauthCode
                }
                if(_this.form.oauthCode){
                  url = 'api/activation'
                }

            }else{
              values = {
                oauth_code: _this.form.oauthCode
              }
            }

            var ajaxPromise = util.ajaxPromise({
                  url: url,
                  method: 'post',
                  values: values
                })
                ajaxPromise.then(function(ret){
                  util.setPrefs('user', ret.data, ret.data.exp)
                  api.toast({msg: ret.msg})

                  api.sendEvent({name: 'loginOrExitSuccess', extra: { type: 'login' }})
                  api.openWin({
                      name: 'html/main',
                      url: 'widget://html/main.html',
                      slidBackEnabled: false
                  })
                  _this.form.mobile = ''
                  _this.form.verify_code = ''
                  _this.form.oauthCode = ''
                  // api.closeWin()
                },function(err){
                    if(err.code === 4006){
                      _this.isNewUser = true
                    }else{
                      api.toast({msg: err.msg || '登录失败'})
                    }
                })
          }
        }
    })
}
