var vm = null
function init() {
  util.slidingClose()
}
apiready = function() {
    init()
    vm = new Vue({
        el: '#vm',
        data: {
          province_id: api.pageParam.province_id,
          province: api.pageParam.province,
          provinceList: [],
          city_id: api.pageParam.city_id,
          city: api.pageParam.city,
          cityList: [],
          region_id: api.pageParam.region_id,
          region: api.pageParam.region,
          regionList: [],
          activeIndex: 0
        },
        methods: {
          getProvinceList: function(){
            var _this = this
            this.activeIndex = 0
            util.ajaxPromise({url: 'area', method: 'get', values: {}}).then(function(ret){
              _this.provinceList = ret.data
            }).fail(function(err){
              api.toast({msg: err.msg})
            })
          },
          handlerClickProvince: function(item){
            var _this = this
            this.province_id = item.id
            this.province = item.name
            this.city = '请选择'
            this.city_id = ''
            this.region = ''
            this.region_id = ''
            this.$refs.container.scrollTop = 0
            util.ajaxPromise({url: 'area', method: 'get', values: {parent_id: item.id}}).then(function(ret){
              _this.cityList = ret.data
              _this.activeIndex = 1
            }).fail(function(err){
              api.toast({msg: err.msg})
            })
          },
          handlerClickCity: function(item){
            var _this = this
            this.city = item.name
            this.city_id = item.id
            this.$refs.container.scrollTop = 0
            util.ajaxPromise({url: 'area', method: 'get', values: {parent_id: item.id}}).then(function(ret){
              if(ret.data.length){
                _this.region = '请选择'
                _this.region_id = ''
                _this.regionList = ret.data
                _this.activeIndex = 2
              }else{
                var params = {
                  province_id: _this.province_id,
                  province: _this.province,
                  city_id: _this.city_id,
                  city: _this.city,
                  region_id: '',
                  region: ''
                }
                api.execScript({
                    name: 'my/attestation/attestation',
                    frameName: 'attestation/index',
                    script: "myAttestationFn('"+JSON.stringify(params)+"')"
                })
                api.closeWin()
              }
            }).fail(function(err){api.toast({msg: err.msg})})
          },
          handlerClickRegion: function(item){
            var _this = this
            this.region = item.fullname
            this.region_id = item.id
            var params = {
              province_id: this.province_id,
              province: this.province,
              city_id: this.city_id,
              city: this.city,
              region_id: this.region_id,
              region: this.region
            }
            api.execScript({
                name: 'my/attestation/attestation',
                frameName: 'attestation/index',
                script: "myAttestationFn('"+JSON.stringify(params)+"')"
            })
            api.closeWin()
          },
          initCity: function(){
            var _this = this
            util.ajaxPromise({url: 'area', method: 'get', values: {parent_id: api.pageParam.province_id}}).then(function(ret){
              _this.cityList = ret.data
            }).fail(function(err){})
          },
          initRegion: function(){
            var _this = this
            util.ajaxPromise({url: 'area', method: 'get', values: {parent_id: api.pageParam.city_id}}).then(function(ret){
              _this.regionList = ret.data
            }).fail(function(err){})
          }
        },
        created: function(){
          this.getProvinceList()
          this.initCity()
          this.initRegion()
        }
    })
}
