var vm = null
function init() {
  util.slidingClose()
}
function myAttestationFn(params){
  var params = JSON.parse(params)
  vm.$data.province = params.province
  vm.$data.city = params.city
  vm.$data.region = params.region
  vm.$data.province_id = params.province_id
  vm.$data.city_id = params.city_id
  vm.$data.region_id = params.region_id
}
apiready = function() {
    init()
    vm = new Vue({
        el: '#vm',
        data: {
          realName: '',
          hospital: '',
          department: '',
          // business: '../../../image/my/attestation/bg-0.jpg',
          // businessLicense: '',
          businessLicense: [],
          province: '',
          city: '',
          region: '',
          province_id: '',
          city_id: '',
          region_id: '',
          adr: '',
          status: 0,
          systemType: api.systemType,
          submitSuccess: false,
          firstLoadDetailEnd: false
        },
        computed: {
          active: function(){
            if(!this.status == 0) return false
            return this.realName && this.hospital && this.department && this.businessLicense.length && this.province_id && this.adr
          },
          isStatus: function(){
            return {
              '0': '待认证',
              '1': '待审核',
              '2': '已通过',
              '3': '未通过'
            }[this.status.toString()]
          }
        },
        methods: {
          handlerAdr: function(){
            if(this.status == 2) return
            api.openWin({
                name: 'my/adr',
                url: '../adr/adr.html',
                pageParam: {
                    province_id: this.province_id,
                    province: this.province,
                    city: this.city,
                    city_id: this.city_id,
                    region_id: this.region_id,
                    region: this.region
                }
            })
          },
          handlerPhotoBrowser: function(index){
            util.openPhotoBrowser({
              imgList: this.businessLicense,
              activeIndex: index
            })
          },
          handlerDel: function(index){
            this.businessLicense.splice(index, 1)
          },
          handlerUpload: function(index){
            if(this.status == 2) return
            var _this = this
            unloadImg.select({isAjaxUpload: true}).then(function(ret){
              // _this.businessLicense = ret.data.real_url
              _this.businessLicense.push(ret.data.real_url)
            })
          },
          // handlerPhotoBrowser: function(index){
          //   var businessLicense = []
          //   businessLicense.push(this.businessLicense)
          //   util.openPhotoBrowser({businessLicense: businessLicense})
          // },
          handlerSubmit: function(){//0=>未审核 0=>已审核 2=> 已审核
            if(this.status == 2) return false
            if(!DgValidator.isName(this.realName)) return api.toast({msg: '名字为中文2~4位'})
            if(!this.hospital) return api.toast({msg: '请输入终端名称'})
            if(!this.department) return api.toast({msg: '请输入主攻科室'})
            if(!this.adr) return api.toast({msg: '请输入详细地址'})
            if(!this.businessLicense.length) return api.toast({msg: '请上传营业执照/执业医师证'})
            // var reg = new RegExp(util.getBaseUrl()+'storage', 'i'),
            //     businessLicense = []
            // for(var i = 0; i < this.businessLicense.length; i++){
            //     // businessLicense.push(this.businessLicense[i].replace(reg, ''))
            //     // businessLicense.push(this.businessLicense[i])
            // }
            var _this = this,
                user = util.getPrefs('user'),
                values = {
                  real_name: this.realName,
                  hospital: this.hospital,
                  department: this.department,
                  province: this.province_id,
                  city: this.city_id,
                  region: this.region_id,
                  adr: this.adr,
                  business_license: this.businessLicense
                }
            api.confirm({
                title: '提示',
                msg: '确定要提交审核吗',
                buttons: ['确定', '取消']
            }, function(ret, err) {
                if(ret.buttonIndex == 1){
                    util.ajaxPromise({url: 'api/user/'+user.user.user_id, method: 'put', values: values}).then(function(ret){
                      api.toast({msg: ret.msg})
                      user.user.profile.real_name = _this.realName
                      user.user.profile.hospital = _this.hospital
                      user.user.profile.department = _this.department
                      user.user.profile.province = _this.province
                      user.user.profile.city = _this.city
                      user.user.profile.region = _this.region
                      user.user.profile.province_id = _this.province_id
                      user.user.profile.city_id = _this.city_id
                      user.user.profile.region_id = _this.region_id
                      user.user.profile.business_license = _this.businessLicense
                      user.user.profile.status = 1
                      util.setPrefs('user', user)
                      _this.submitSuccess = true
                      api.sendEvent({name: 'loginOrExitSuccess', extra: { type: 'login' }})
                      // setTimeout(function(){api.closeWin()}, 2000)
                    }).fail(function(err){
                      api.toast({msg: err.msg})
                    })
                }
            })
          },
          getPrefsUserInfo: function() {
            var _this = this,
                user =  util.getPrefs('user') || { user: {} }
                this.realName = user.user.profile.real_name
                this.hospital = user.user.profile.hospital
                this.department = user.user.profile.department
                this.province = user.user.profile.province
                this.city = user.user.profile.city
                this.region = user.user.profile.region
                this.province_id = user.user.profile.province_id
                this.city_id = user.user.profile.city_id
                this.region_id = user.user.profile.region_id
                this.adr = user.user.profile.adr
                this.businessLicense = user.user.profile.business_license || []
                this.status = user.user.profile.status
                // user.user.profile.status
                setTimeout(function(){
                  _this.firstLoadDetailEnd = true
                }, 30)
          }
        },
        created: function(){
          this.getPrefsUserInfo()
        }
    })
}
