var header = null,
    headerHeight = null,
    vm = null
function init() {
  header = $api.byId('header')
  headerHeight = $api.fixStatusBar(header)
  util.slidingClose()
}
apiready = function() {
    init()
    vm = new Vue({
        el: '#vm',
        data: {
          key: '',
          value: '',
          text: '',
          placeholder: '',
          active: true,
          isSubmitIng: false,
          profileState: ['hospital', 'workname']
        },
        methods: {
          handlerClear: function(){
            this.value = ''
          },
          validator: function(){
            var key = this.key,
                value = this.value
            switch (key) {
              case 'name':
                    return value.length > 0 ? true : !!api.toast({msg: '请输入名字'})
              case 'mobile':
                    return DgValidator.isMobile(value) ? true : !!api.toast({msg: '请输入正确的手机号码'})
              case 'email':
                    return DgValidator.isEmail(value) ? true : !!api.toast({msg: '请输入正确的邮箱'})
              case 'hospital':
                    return value.length > 0 ? true : !!api.toast({msg: '请输入医院或者公司'})
              case 'workname':
                    return value.length > 0 ? true : !!api.toast({msg: '请输入职务或者职称'})
              default:
                    return !!api.toast({msg: '操作失败'})
            }
          },
          handlerConfirm: function(){
            if(!this.validator()) return false
            var _this = this,
                user = util.getPrefs('user'),
                values = {}
            if(this.key === 'name'){
              values.name = this.value
            }else if(this.profileState.indexOf(this.key) >= 0){//如果是修改profile里面的属性 不需要传name给后端
              values[this.key] = this.value
            }else{
              values.name = user.user.name
              values[this.key] = this.value
            }
            if(this.isSubmitIng) return
            this.isSubmitIng = true
            util.ajaxPromise({url: 'api/user/'+user.user.user_id, method: 'put', values: values}).then(function(ret){
              api.toast({msg: ret.msg})
              if(_this.profileState.indexOf(_this.key) >= 0){//profile中的属性
                user.user.profile[_this.key] = _this.value
              }else{
                user.user[_this.key] = _this.value
              }
              util.setPrefs('user', user)
              var params = {type: 'updateUserInfo'}
              params = $api.jsonToStr(params)
              api.execScript({name: 'html/main',frameName: 'my/index',script: "myIndexFn('"+params+"')"})
              api.execScript({name: 'my/info/info',frameName: 'info/index',script: "myInfoIndex('"+params+"')"})
              setTimeout(function(){api.closeWin()}, 2000)
            }).fail(function(err){
              api.toast({msg: err.msg})
            }).finally(function(){
              _this.isSubmitIng = false
            })
          }
        },
        created: function(){
          this.key = api.pageParam.key
          this.text = api.pageParam.text
          this.value = (api.pageParam.value ? api.pageParam.value : '')
          this.placeholder = api.pageParam.placeholder
        },
        watch: {
          'value': function(){
            var key = this.key,
                value = this.value
                switch (key) {
                  case 'name':
                      this.active = value.length > 0 ? true : false
                      break
                  case 'mobile':
                      this.active = DgValidator.isMobile(value)
                      break
                  case 'email':
                      this.active = DgValidator.isEmail(value)
                      break
                  case 'hospital':
                      this.active = value.length > 0 ? true : false
                      break
                  case 'workname':
                      this.active = value.length > 0 ? true : false
                      break
                  default:
                }
          }
        }
    })
}
