
    apiready = function() {
        init()
        vm = new Vue({
            el: '#vm',
            data: {
              cacheSize: '0.00M',
              appVersion: '',
              downloadProgress: 0,
              user: {},
              systemType: api.systemType
            },
            methods: {
              handlerFeedback: function(){
                api.openWin({
                    name: 'feedback/feedback',
                    url: '../feedback/feedback.html',
                    bounces: false,
                    animation: {
                      type: 'movein',
                      duration: 300
                    }
                })
              },
              getCacheSize: function(){
                  var _this = this
                  api.getCacheSize(function(ret) {
                      var size = ret.size
                      var value = {
                        '-1': '无存储设备',
                        '-2': '正在准备USB存储设备',
                        '-3': '无法访问存储设备'
                      }[size]
                      _this.cacheSize = value ? value : (size / 1000 / 1024).toFixed(2) + 'M'
                  })
              },
              getAppVersion: function(){
                this.appVersion = api.appVersion
              },
              handlerClearCache: function(){
                  var _this = this
                  api.clearCache(function() {
                    api.toast({msg: '清除完成'})
                    _this.cacheSize = '0.00M'
                  })
              },
              uiActionProgress: function(value){
                UIActionProgress = api.require('UIActionProgress')
                UIActionProgress.open({
                    maskBg: 'rgba(0,0,0,0.5)',
                    styles: {
                        h: 108,
                        bg: '#fff',
                        title: {
                            size: 16,
                            color: '#000',
                            marginT: 10
                        },
                        lable: {
                            size: 14,
                            color: '#666',
                            marginB: 10
                        },
                        progressBar: {
                            size: 5,
                            normal: '#d9d9d9',
                            active: '#008ad5',
                            marginB: 35,
                            margin: 5
                        }
                    },
                    data: {
                        title: '正在更新',
                        value: value || 0
                    }
                },function(ret){
                    if(ret.eventType === 'click'){
                      UIActionProgress.close()
                    }
                })
              },
              handlerCheckUpdatePromise: function(){
                if(this.systemType === 'ios') return
                if(!UIActionProgress || this.downloadProgress == 0){
                  this.checkUpdate()
                }else{
                  this.uiActionProgress(this.downloadProgress)
                }
              },
              checkUpdate: function(){
                var mam = api.require('mam'),
                    _this = this
                mam.checkUpdate(function(ret, err) {
                    if (ret) {
                        var result = ret.result
                        if (result.update == true && result.closed == false) {
                            var text = '新版本型号:' + result.version + ';更新提示语:' + result.updateTip + '发布时间:' + result.time
                            api.confirm({
                                title : '有新的版本,是否下载并安装 ',
                                msg : text,
                                buttons : ['确定', '取消']
                            }, function(ret, err) {
                                if (ret.buttonIndex == 1) {
                                    if (api.systemType === 'android') {
                                        _this.uiActionProgress()
                                        api.download({
                                            url : result.source,
                                            report : true
                                        }, function(ret, err) {
                                            if (ret && 0 == ret.state) {/* 下载进度 */
                                                _this.downloadProgress = ret.percent
                                                UIActionProgress.setData({data: {title: '正在更新',value: ret.percent}})
                                            }
                                            if (ret && 1 == ret.state) {/* 下载完成 */
                                                UIActionProgress.close()
                                                _this.downloadProgress = 0
                                                var savePath = ret.savePath
                                                api.installApp({appUri : savePath})
                                            }
                                        })
                                    }else if(api.systemType === 'ios') {
                                        api.installApp({appUri : result.source})
                                    }
                                }
                            })
                        } else {
                          api.toast({
                            msg: '你使用的版本已是最新的了哦',
                            duration: 2000,
                            location: 'bottom'
                          })
                        }
                    } else {
                        api.alert({
                            msg : err.msg
                        })
                    }
                })
              },
              handlerExitLogin: function(){
                var _this = this
                api.confirm({
                      title: '提示',
                      msg: '是否要退出登录',
                      buttons: ['确定', '取消']
                  }, function(ret, err) {
                      if(ret.buttonIndex == 1) {
                        api.removePrefs({key: 'user'})
                        util.openLogin({exitLogin: true})
                        _this.getPrefsUserInfo()
                        api.sendEvent({name: 'loginOrExitSuccess', extra: { type: 'exit' }})
                      }
                  })
              },
              getPrefsUserInfo: function(){
                var user = util.getPrefs('user') || { user: { notLogin: true } }
                this.user = user.user
              }
            },
            created: function(){
              this.getCacheSize()
              this.getAppVersion()
              this.getPrefsUserInfo()
            }
        })
    }
    var header = null,
        vm = null,
        UIActionProgress = null

    function init() {
        header = $api.byId('header')
        $api.fixStatusBar(header)
        util.slidingClose()
        api.addEventListener({//登录成功
            name: 'loginOrExitSuccess'
        }, function(ret, err){
            var type = ret.value.type
            if(type === 'login'){
              vm.getPrefsUserInfo()
            }
        })
    }
