var vm = null
apiready = function() {
    init()
    vm = new Vue({
        el: '#vm',
        data: {
          firstLoadDetailEnd: false,
          noData: true,
          list: []
        },
        methods: {
          handlerReplay: function(id, position){
            util.relNameAndVip().then(function(){
              api.openWin({
                  name: 'video/replay/replay',
                  url: 'widget://html/video/replay/replay.html',
                  animation: {
                    type: 'movein',
                    subType: 'from_right',
                    duration: 300
                  },
                  pageParam: {
                    id: id,
                    position: position
                  },
                  slidBackEnabled: false
              })
            }).fail(function(){})
          },
          getList: function(){
            var _this = this,
                videoUrl = 'api/history'
            var videoAjaxPromise = util.ajaxPromise({url: videoUrl, method: 'get'})
            videoAjaxPromise.then(function(ret){
              _this.list = ret.data
              _this.noData = ret.data.length
            }).fail(function(err){
              api.toast({msg: err.msg})
            }).finally(function(){
              _this.firstLoadDetailEnd = true
              util.closeUiLoading()
            })
          }
        },
        created: function(){
          this.getList()
        },
        filters: {
          time: function(v){
            var d = new Date(v * 1000),
                weeks = ['星期日','星期一','星期二','星期三','星期四','星期五','星期六'],
                year = d.getFullYear(),
                mouth = d.getMonth() + 1,
                day = d.getDate(),
                hour = d.getHours() < 10 ? '0' + d.getHours() : d.getHours(),
                minutes = d.getMinutes() < 10 ? '0' + d.getMinutes() : d.getMinutes(),
                second = d.getSeconds() < 10 ? '0' + d.getSeconds() : d.getSeconds(),
                weekIndex = d.getDay()
            var week = weeks[weekIndex]
                return year + '-' + mouth + '-' + day + ' ' + hour + ':' + minutes + ':' + second
          },
          millisecondToDate: function(msd){
              var time = parseFloat(msd)
              function addLin(num){
                return num < 10 ? '0' + num : num
              }
              if (null != time && '' != time) {
                  if (time > 60 && time < 60 * 60) {
                      time = addLin(parseInt(time / 60.0)) + ':' + addLin(parseInt((parseFloat(time / 60.0) -
                          parseInt(time / 60.0)) * 60))
                  }else if (time >= 60 * 60 && time < 60 * 60 * 24) {
                      time = addLin(parseInt(time / 3600.0)) + ':' + addLin(parseInt((parseFloat(time / 3600.0) -
                          parseInt(time / 3600.0)) * 60)) + ':' +
                          addLin(parseInt((parseFloat((parseFloat(time / 3600.0) - parseInt(time / 3600.0)) * 60) - parseInt((parseFloat(time / 3600.0) - parseInt(time / 3600.0)) * 60)) * 60))
                  }else {
                      time = '>24小时'
                  }
              }
              return time
          }
        }
    })
}

function init() {
  util.openUiLoading()
  util.slidingClose()
  api.addEventListener({
      name: 'closeVideoReplayPage'
  }, function(ret, err){
      addRecord(ret)
  })
}
function addRecord(ret){
  var _this = this,
      videoUrl = 'api/video/'
  var videoAjaxPromise = util.ajaxPromise({url: videoUrl, method: 'post', values: ret.value})
      videoAjaxPromise.then(function(ret){
        vm.getList()
      })
}
