var header = null,
    headerHeight = null,
    vm = null,
    video = null,
    move = null,
    videoOuter = null,
    playPositionBar = null,
    myScroll = null,
    frameWidth = null,
    frameHeight = null

function init(){
  header = $api.byId('header'),
  headerHeight = $api.fixStatusBar(header)
  frameWidth = api.frameWidth
  frameHeight = api.frameHeight
  api.addEventListener({
      name: 'keyback'
  }, function(ret, err){
    if(vm.$data.video.landscapeLeft){
      videoOuter.style.height = parseInt($api.cssVal($api.dom('html'), 'font-size')) * 11.75 + 'px'
      api.setScreenOrientation({orientation: 'portrait_up'})
      vm.$data.video.landscapeLeft = false
      api.setFullScreen({fullScreen: false})
    }else{
      vm.handlerClose()
    }
  })
}

apiready = function(){
  init()
  vm = new Vue({
    el: '#vm',
    data: {
      noData: true,
      loadMoreGIF: false,
      loadAll: false,
      isSubmitIng: false,
      isStarIng: false,
      content: '',
      commentToatl: 0,
      tabs: ['简介', '留言'],
      activeIndex: 0,
      systemType: api.systemType,
      params: {},
      data: {
        author_brief: '',
        brief: ''
      },
      userComment: [],
      duration: 0,
      currentPosition: 0,
      historyTime: 0,
      orientation: false,
      pullUpIng: false,
      video: {
        playing: false,
        waiting: true,
        landscapeLeft: false,
        barOuter: true,
        timer: null,
        moveIng: false,
        ended: false
      }
    },
    methods: {
      handlerClickVideo: function(){
        var _this = this
        this.video.barOuter = true
        clearTimeout(this.video.timer)
        this.video.timer = setTimeout(function(){
          if(!_this.video.moveIng){
            _this.video.barOuter = false
          }
        }, 5000)
      },
      handlerTimeupdate: function(){
        this.currentPosition = video.currentTime
        this.duration = video.duration || 0
        if(!this.video.moveIng){
          playPositionBar.style.WebkitTransform = 'translateX('+((this.currentPosition / this.duration) * 100 - 100) +'%)'
          var Left = this.currentPosition / this.duration * api.frameWidth
          if(Left > api.frameWidth - move.offsetWidth){
            Left = api.frameWidth - move.offsetWidth
          }
          move.style.left = Left / api.frameWidth * 100 + '%'
        }
      },
      handlerLoadedmetadata: function(){
        video.currentTime = this.historyTime
      },
      handlerToPosition: function(e){
        var Left = e.clientX
        if(Left < 0) {
            Left = 0
           }else if(Left > api.frameWidth - move.offsetWidth) {
            Left = api.frameWidth - move.offsetWidth
           }
        move.style.left = Left / api.frameWidth * 100 + '%'
        playPositionBar.style.WebkitTransform = 'translateX('+((Left / api.frameWidth) * 100 - 100) +'%)'
        video.currentTime = Left / api.frameWidth * this.duration
      },
      handlerEnded: function(){
        this.video.playing = false
        this.video.ended = true
      },
      handlerClickPause: function(){
        this.video.playing = false
        video.pause()
      },
      handlerClickPlay: function(){
        this.video.playing = true
        this.video.ended = false
        video.play()
      },
      handlerWaiting: function(){
        this.video.waiting = true
      },
      handlerCanplay: function(){
        this.video.waiting = false
        this.video.ended = false
        video.play()
        this.handlerClickVideo()
      },
      handlerPlay: function(){
        this.video.waiting = false
        this.video.ended = false
      },
      handlerPlaying: function(){
        this.video.playing = true
        this.video.waiting = false
        this.video.ended = false
      },
      handlerFull: function(){
        this.video.landscapeLeft = !this.video.landscapeLeft
        if(this.video.landscapeLeft){
          videoOuter.style.height = frameWidth + 'px'
        }else{
          videoOuter.style.height = parseInt($api.cssVal($api.dom('html'), 'font-size')) * 11.75 + 'px'
        }
        api.setFullScreen({fullScreen: this.video.landscapeLeft})
        api.setScreenOrientation({orientation: (this.video.landscapeLeft ? 'landscape_left' : 'portrait_up')})
      },
      getTime: function(){
        var d = new Date(),
            weeks = ['星期日','星期一','星期二','星期三','星期四','星期五','星期六'],
            year = d.getFullYear(),
            mouth = d.getMonth() + 1,
            day = d.getDate(),
            hour = d.getHours() < 10 ? '0' + d.getHours() : d.getHours(),
            minutes = d.getMinutes() < 10 ? '0' + d.getMinutes() : d.getMinutes(),
            second = d.getSeconds() < 10 ? '0' + d.getSeconds() : d.getSeconds(),
            weekIndex = d.getDay()
        var week = weeks[weekIndex]
            return year + '-' + mouth + '-' + day + ' ' + hour + ':' + minutes + ':' + second
      },
      handlerSwitch: function(index){
        var _this = this
        this.activeIndex = index
        if(index === 1 && !myScroll){
          this.$nextTick(function(){
            _this.iscroll()
          })
        }
      },
      handlerStar: function(){
        var _this = this,
            videoUrl = 'api/video_star/' + api.pageParam.id
        var videoAjaxPromise = util.ajaxPromise({url: videoUrl, method: 'get'})
        if(this.isStarIng) return
        this.isStarIng = true
        videoAjaxPromise.then(function(ret){
          _this.data.stars_count = ret.data.stars_count
          api.toast({msg: ret.msg})
        }).fail(function(err){
          api.toast({msg: err.msg})
        }).finally(function(){
          _this.isStarIng = false
        })
      },
      handlerClose: function(){
        if(this.duration != 0){
          api.sendEvent({name: 'closeVideoReplayPage',extra: {
            id: api.pageParam.id,
            duration: this.duration,
            position: this.currentPosition
          }})
        }
        api.closeWin()
      },
      getHistory: function(){//获取播放记录
        var _this = this,
            videoUrl = 'api/history'
        var videoAjaxPromise = util.ajaxPromise({url: videoUrl, method: 'get'})
        videoAjaxPromise.then(function(ret){
          for(var i = 0; i < ret.data.length; i++){
            if(ret.data[i].id == api.pageParam.id){
              _this.historyTime = ret.data[i].position
            }
          }
        })
      },
      detail: function(){
        var _this = this,
            videoUrl = 'api/video/' + api.pageParam.id
        var videoAjaxPromise = util.ajaxPromise({url: videoUrl, method: 'get'})
        videoAjaxPromise.then(function(ret){
          _this.data = ret.data
          api.pageParam.position && (_this.historyTime = api.pageParam.position)
        }).fail(function(err){
          api.toast({'msg': err.msg})
        }).finally(function(){})
      },
      handlerAddComment: function(){
        if(!util.isLogin()){
          return util.isLogin(true)
        }
        if(this.isSubmitIng || !this.content) return
        this.isSubmitIng = true
        var _this = this,
            url = 'api/user_comment',
            user = util.getPrefs('user')
        var ajaxPromise = util.ajaxPromise({
          url: url,
          method: 'post',
          values: {
            video_id: api.pageParam.id,
            user_id: user.user.user_id,
            type: 'video',
            content: _this.content
          }
        })
        ajaxPromise.then(function(ret){
          var constructrData = {
            content: _this.content,
            user_id: user.user.user_id,
            created_at: _this.getTime(),
            user: user.user
          }
          _this.userComment.unshift(constructrData)
          _this.content = ''
          _this.commentToatl++
          _this.noData = true
          api.toast({msg: ret.msg, location: 'middle'})
          _this.$refs.input.blur()
          _this.$nextTick(function(){
            myScroll.refresh()
          })
        }).fail(function(){
          api.toast({msg: ret.msg})
        }).finally(function(){
          _this.isSubmitIng = false
        })
      },
      more: function(){
        var _this = this
        util.ajaxPromise(this.params).then(function(ret){
          _this.userComment = _this.userComment.concat(ret.data.data)
          _this.noData = _this.userComment.length
          _this.commentToatl = ret.data.total
          _this.$nextTick(function(){
            myScroll && myScroll.refresh()
          })
        }).finally(function(){
          _this.loadMoreGIF = false
          _this.pullUpIng = false
        })
      },
      load: function(){
        var _this = this,
            newUrl = 'api/user_comment'
            this.params = {
              url: newUrl,
              method: 'get',
              values: {new_id: api.pageParam.id, type: 'video', page: 1},
              ajaxLoading: function(){
                _this.loadMoreGIF = true
                _this.noData = true
                if(myScroll){
                  myScroll.refresh()
                  _this.params.values.page !=1 && myScroll.scrollTo(0, myScroll.y - $api.offset($api.byId('GifH')).h, 1000)
                }
              },
              ajaxLoadAll: function(){
                _this.loadAll = true
              }
            }
        _this.more(this.params)
      },
      iscroll: function(){
        var _this = this
        myScroll = new IScroll('#wrapper', { scrollbars: true, fadeScrollbars: true, preventDefault: false, freeScroll: true })
        myScroll.on('scrollEnd', function(){
          if(_this.loadAll || _this.pullUpIng) return
          if(myScroll.maxScrollY == myScroll.y){
              _this.pullUpIng = true
              _this.params.values.page++
              _this.more()
          }
        })
      },
      drag: function(){
          var _this = this,
              disX = 0,
              Left = 0
              move.addEventListener('touchstart',function(e){
                e.preventDefault()
                disX = e.touches[0].pageX - move.offsetLeft
                _this.video.moveIng = true
                // if(e.touches.length==1){}
                  move.addEventListener('touchmove',function(e){
                    e.preventDefault()
                    Left = e.touches[0].pageX - disX
                    if(Left < 0) {
                        Left = 0
                       }else if(Left > api.frameWidth - move.offsetWidth) {
                        Left = api.frameWidth - move.offsetWidth
                       }
                    move.style.left = Left / api.frameWidth * 100 + '%'
                    playPositionBar.style.WebkitTransform = 'translateX('+((Left / api.frameWidth) * 100 - 100) +'%)'
                  },false)

              },false)
              move.addEventListener('touchend',function() {
                video.currentTime = Left / api.frameWidth * _this.duration
                _this.video.moveIng = false
              },false)
      }
    },
    filters: {
      addHttp: function(url){
        return url ? (url.substr(0, 7).toLowerCase() === 'http://' ? url : 'http://' + url) : url
      },
      secondToDate: function(v){
        var h = Math.floor(v / 3600),
            m = Math.floor((v / 60 % 60)),
            s = Math.floor((v % 60))

            m = m < 10 ? '0' + m : m
            s = s < 10 ? '0' + s : s
            if(h == 0){
              return result = m + ' : ' + s
            }else{
              h = h < 10 ? '0' + h : h
              return result = h + ' : ' + m + ' : ' + s
            }
      },
    },
    directives: {
      rich: {
        inserted: function(el, binding){
          el.innerHTML = binding.value
        },
        update: function(el, binding){
          el.innerHTML = binding.value
        }
      }
    },
    created: function(){
      this.detail()
      this.load()
    },
    mounted: function(){
      video = document.querySelector('video')
      videoOuter = document.getElementById('video-outer')
      playPositionBar = document.getElementById('play-position-bar')
      move = document.getElementById('move')
      this.getHistory()
      // var _this = this
      // _this.orientation = true
      // video.addEventListener('webkitfullscreenchange', function(e) {
      //   _this.orientation = !_this.orientation
      //   api.setScreenOrientation({
      //     orientation: _this.orientation ? 'portrait_up' : 'landscape_left'
      //   })
      // })

      // video.addEventListener('webkitbeginfullscreen', function(e) {
        // _this.bool = !_this.bool
        // api.setScreenOrientation({
        //   orientation: _this.bool ? 'portrait_up' : 'landscape_left'
        // })
      // })
      // video.addEventListener('webkitendfullscreen', function(e) {
      //   _this.bool = !_this.bool
      // })
      this.drag()
    }
  })
}
