var util = {
  slidingClose: function(name){//安卓右滑关闭window
    api.addEventListener({
           name:'swiperight'
       },function(ret,err){
           api.closeWin({name: name || ''})
    })
  },
  imageCache: function(array, replaceKey){//图片缓存 array=>数据列表 图片字段的key
    for(var i = 0; i < array.length; i++){
      (function(i){
        api.imageCache({
            url: array[i][replaceKey]
        }, function(ret, err) {
            ret.status && (array[i][replaceKey] = ret.url)
        })
      })(i)
    }
  },
  imageCacheSingle: function(url, cb){
    api.imageCache({
        url: url
    }, function(ret, err) {
        typeof cb === 'function' && cb(ret.url)
    })
  },
  map: function(array, key){
    return array.map(function(item){
      return item[key]
    })
  },
  isLogin: function(isTo){//判断用户是否已经登录 isTo=true 需要跳转
    if(util.getPrefs('user')){
      return true
    }else{
      isTo && util.openLogin()
      return false
    }
  },
  openLogin: function(pageParam){
    pageParam = pageParam ? pageParam : {}
    api.openWin({name: 'html/login/login',url: 'widget://html/login/login.html', pageParam: pageParam, slidBackEnabled: false, softInputMode: 'pan'})
  },
  buildParams: function(prefix, obj, traditional, add){
      var name
      if ( Array.isArray( obj ) ) {
        if(!obj.length){
          add( prefix, [] )
        }else{
          obj.forEach(function(v, i){
            if ( traditional || /\[\]$/.test( prefix ) ) {
              add( prefix, v )
            } else {
              util.buildParams(
                prefix + '[' + ( typeof v === 'object' && v != null ? i : '' ) + ']',
                v,
                traditional,
                add
              )
            }
          })
        }
      } else if ( !traditional && typeof obj === 'object' ) {
        for ( name in obj ) {
          util.buildParams( prefix + '[' + name + ']', obj[ name ], traditional, add )
        }

      } else {
        add( prefix, obj )
      }
  },
  param: function(a, traditional){
      var prefix,
  			s = [],
  			add = function( key, valueOrFunction ) {
  				var value = typeof valueOrFunction === 'function' ? valueOrFunction() : valueOrFunction
  				var tempValue
  				if(Array.isArray(value) && !value.length){
  					tempValue = '[]'
  				}else{
  					tempValue = encodeURIComponent( value == null ? '' : value )
  				}
  				s[ s.length ] = encodeURIComponent( key ) + '=' + tempValue
  			}

  		if ( Array.isArray( a ) ) {
  			a.forEach(function(v, i){
  				add( i, v )
  			})
  		} else {
  			for ( prefix in a ) {
  				util.buildParams( prefix, a[ prefix ], traditional, add );
  			}
  		}
  		return s.join( '&' )
  },
  getBaseUrl: function(){
    // return 'http://www.broadcast.com/' //本地廖锐
    // return 'http://www.hep.loc/'// 本地 雪原
    // return 'http://hep.com/' //本地 立群
    return 'http://hep.maissy.net/'
  },
  ajax: function(params){
        if(!params.url) return api.toast({msg: 'url必传', global: true})
        var baseUrl = util.getBaseUrl(),
            method = params.method || 'post',
            values = params.values || {},
            files = params.files
            var user = util.getPrefs('user'),
                Authorization = 'Bearer jwt-token to be insert'
            var headers = {},
                data = {}
            user && (headers.Authorization = 'Bearer ' + ( user.token || 'jwt-token to be insert'))
            if(files){//上传文件（图片）
              data.files = files
            }else{
              headers['Content-Type'] = 'application/x-www-form-urlencoded; charset=UTF-8'
              // application/json
              if(method === 'post' || method === 'put'){
                data.body = util.param(values, false)
              }else{
                data.values = values
              }
            }
            typeof params.ajaxLoading === 'function' && params.ajaxLoading()
            api.ajax({
                url: baseUrl + params.url,
                method: method,
                headers: headers,
                encode: true,
                data: data
            },
            function(ret, err) {
              if(typeof params.resolve === 'function' || params.reject === 'function'){
                if(ret){
                  ret.status == 0 ? params.reject(ret) : params.resolve(ret)
                  if(ret.statusCode == 401 || ret.status == 401){//token过期
                    api.removePrefs({key: 'user'})
                    util.openLogin()
                  }
                }else{
                  api.toast({msg: err.msg})
                  params.reject(err)
                  if(err.statusCode == 401 || err.status == 401){//token过期
                    api.removePrefs({key: 'user'})
                    util.openLogin()
                  }
                }
              }
              if(ret && ret.data && Number(ret.data.current_page) === Number(ret.data.last_page)){//加载完毕
                params.noRemoveScrolltobottom || api.removeEventListener({name: 'scrolltobottom'})
                typeof params.ajaxLoadAll === 'function' && params.ajaxLoadAll()
              }
            })
  },
  ajaxPromise: function(params){
      var deferred = Q.defer()
      params.resolve = deferred.resolve
      params.reject = deferred.reject
      util.ajax(params)
      return deferred.promise
  },
  more: function(params){
      api.addEventListener({
        name:'scrolltobottom',
        extra:{
          threshold: params.threshold || 300
        }
      }, function(ret, err){
        typeof params.moreCallback === 'function' && params.moreCallback()
      })
  },
  refresh: function(callback){
    api.setRefreshHeaderInfo({
        loadingImg: 'widget://image/common/icon-transparent.png',
        bgColor: '#F2F4F8',
        textColor: '#999',
        textDown: '下拉刷新...',
        textUp: '松开刷新...',
        showTime: false
      }, function(ret, err) {
          ret ? callback('success') : callback('fail')
      })
  },
  openPhotoBrowser: function(params){
    api.openWin({
        name: 'html/photo_browser/photo_browser',
        url: 'widget://html/photo_browser/photo_browser.html',
        pageParam: params,
        animation: {
          type: 'fade',
          duration: 300
        }
    })
  },
  setPrefs: function(key, value, timeStamp){
    var length = arguments.length
    if(length === 2 || length === 3){
        var v = value
        if(length === 3 && (typeof v !== 'object')) throw new Error('如果需要设置过期时间，value必须是Object')
        if(typeof v == 'object'){
            if(key === 'user'){//暂时user有过期时间
              var ret = util.getPrefs(key)
              if(timeStamp){
                v.__timeStamp = String(timeStamp).length === 10 ? timeStamp * 1000 : timeStamp
              }else if(ret){
                v.__timeStamp = ret.__timeStamp
              }
            }
            v = JSON.stringify(v)
            v = 'obj-'+ v
        }else{
            v = 'str-'+ v
        }
    }
    api.setPrefs({key: key, value: v})
  },
  getPrefs: function(key){
    var v = api.getPrefs({sync: true,key: key})
    if(!v){return null}
    if(v.indexOf('obj-') === 0){
        v = v.slice(4);
        var data = JSON.parse(v),
            timeStamp = data.__timeStamp
        if(typeof timeStamp === 'number' && timeStamp <= Date.parse(new Date())){
            api.removePrefs(key)
            // api.toast({msg: '登录已过期，请重新登录', location: 'middle'})
            util.openLogin()
            return null
        }
        return data;
    }else if(v.indexOf('str-') === 0){
        return v.slice(4)
    }
  },
  getArrItem: function(arr, key){//提取数组中的某一项
    if(!key) throw new Error('key is required')
    var res = []
    for(var i = 0; i < arr.length; i++){
      res.push(arr[i][key])
    }
    return res
  },
  relNameAndVip: function(){
    var deferred = Q.defer()
    if(!util.isLogin()){//判断是否登录 目前业务逻辑是用户进来app必须是登录的了
      setTimeout(function(){
        deferred.reject()
        util.isLogin(true)
      }, 0)
    }
    // '0': '未认证','1': '认证中','2': '已认证','3': '未通过'
    var user = util.getPrefs('user'),
        status = user.user.profile.status
        if(status == 0){
          setTimeout(function(){
            deferred.reject()
            util.openAttestation()
          }, 0)
        }else if(status == 1){
          setTimeout(function(){
            deferred.reject()
            api.toast({msg: '你的账号在认证中, 还不能进行此操作'})
          }, 0)
        }else if(status == 3){
          setTimeout(function(){
            deferred.reject()
            api.toast({msg: '实名认证失败，请重新认证'})
          }, 0)
        }else if(status == 2){
          var vip = util.isVip(user.user.vip_overtuetime)
          if(vip == 1){
            setTimeout(function(){
              deferred.resolve()
            }, 0)
          }else if(vip == 0){
            setTimeout(function(){
              deferred.reject()
              util.openScan()
            }, 0)
          }else{
            setTimeout(function(){
              deferred.reject()
              if(api.systemType === 'android'){
                var title = '您的VIP已过期',
                    msg = '您所选择的服务仅为VIP用户提供，请扫码续VIP'
              }else{
                var title = '你没有活跃值了',
                    msg = '您所选择的服务仅为有活跃值的用户提供，请扫码增加活跃值'
              }
              util.openScan(title, msg)
            }, 0)
          }
        }

    return deferred.promise
  },
  isVip: function(vipOvertuetime){
    // 0=>还不是vip 1=>vip用户 2=>vip已过期
    if(!vipOvertuetime) return 0
    var t1 = new Date().getTime(),
        t2 = new Date(vipOvertuetime.replace(/-/g, '/')).getTime()
        return t2 - t1 > 0 ? 1 : 2
  },
  isRelName: function(){
    var user = util.getPrefs('user'),
        status = user.user.profile.status
      if(status == 0){
        return
      }else if(status == 1){
        return api.toast({msg: '你的账号在实名认证中'})
      }
  },
  openAttestation: function(){
      api.confirm({
            title: '账号认证',
            msg: '您所选择的服务仅为认证用户提供，请完成实名认证',
            buttons: ['完成账号认证', '下次再说']
        }, function(ret, err) {
            if(ret.buttonIndex == 1){
              api.openWin({
                  name: 'my/attestation/attestation',
                  url: 'widget://html/my/attestation/attestation.html',
                  bounces: false,
                  animation: {
                    type: 'middle',
                    duration: 300
                  },
                  pageParam: {}
              })
            }
        })
  },
  openScan: function(title, msg){
    var _this = this,
        user = util.getPrefs('user')
        if(user.user.profile.status != 2) return api.toast({'msg': '请先实名认证'})
        if(api.systemType === 'android'){
          var titleText = 'VIP账号激活',
              msgText = '您所选择的服务仅为VIP用户提供，请扫码续VIP',
              buttonText = '扫码续VIP'
        }else{
          var titleText = '活跃值',
              msgText = '您所选择的服务仅为有活跃值的用户提供，请扫码增加活跃值',
              buttonText = '增加活跃值'
        }
        api.confirm({
              title: title || titleText,
              msg: msg || msgText,
              buttons: [buttonText, '下次再说']
          }, function(ret, err) {
              if(ret.buttonIndex == 1){
                var FNScanner = api.require('FNScanner')
                FNScanner.open({
                    autorotation: true
                }, function(ret, err) {
                  if(ret && ret.eventType === 'success'){
                    util.ajaxPromise({url: 'api/cards/used', method: 'post', values: {
                      code: ret.content
                    }}).then(function(ret){
                        var date = ret.data
                        user.user.vip_overtuetime = date
                        util.setPrefs('user', user)
                        api.toast({msg: ret.msg})
                    }).fail(function(err){
                      api.toast({msg: err.msg})
                    })
                  }
                  err && api.toast({msg: err.msg})
                })
              }
          })
  },
  openUiLoading: function(id){
    var UILoading = api.require('UILoading')
    UILoading.flower({
        center: {
            x: api.winWidth / 2,
            y: api.winHeight / 2
        },
        size: 45,
        fixed: true,
        id: (id ? id : 'UILoading')
    }, function(ret) {})
  },
  closeUiLoading: function(id){
    var UILoading = api.require('UILoading')
    UILoading.closeFlower({id: (id ? id : 'UILoading')})
  },
  realName: function(){
    var user = util.getPrefs('user')
    if(user) return null
    var status = user.user.profile.status
  },
  loadScript: function(url, callback){
    var script = document.createElement('script')
    script.type = 'text/javascript'
    if(typeof(callback) != 'undefined'){
      if (script.readyState) {
        script.onreadystatechange = function () {
          if (script.readyState == 'loaded' || script.readyState == 'complete') {
            script.onreadystatechange = null
            callback()
          }
        }
      } else {
        script.onload = function () {
          callback()
        }
      }
    }
    script.src = url
    document.body.appendChild(script)
  },
  openAdvPage: function(data){//type:1是文章   type:2是直播  type:3是点播
    var url = data.url,
        jumpParam = data.jump_param
        if(!jumpParam){
          if(url){
            var browser = api.require('webBrowser')
                browser.open({url: url})
          }
        }else{
          var id = jumpParam.id,
              type = jumpParam.type
              if(!id){
                if(url){
                  var browser = api.require('webBrowser')
                      browser.open({url: url})
                }
                return
              }
              type = Number(type)
              switch (type) {
                case 1: //文章
                  openWin('new/detail/detail','widget://html/new/detail/detail.html',id)
                  break
                case 2://直播
                  if(_isVip()) return
                  openWin('video/liveing/detail', 'widget://html/video/liveing/detail.html', id)
                  break
                case 3: //点播播
                  if(_isVip()) return
                  openWin('video/replay/replay','widget://html/video/replay/replay.html',id)
                  break
                default:
              }
        }
        // console.log(_isVip())
        function _isVip(){
          var user = util.getPrefs('user'),
              status = user.user.profile.status
              if(status == 0){
                return !util.openAttestation()
              }else if(status == 1){
                return !api.toast({msg: '你的账号在认证中,还不能观看视频'})
              }
          var ret = util.isVip(user.user.vip_overtuetime)
              if(ret == 0){
                return !util.openScan()
              }else if(ret == 2){
                if(api.systemType === 'android'){
                  var title = '您的VIP已过期',
                      msg = '您所选择的服务仅为VIP用户提供，请扫码续VIP'
                }else{
                  var title = '你没有活跃值了',
                      msg = '您所选择的服务仅为有活跃值的用户提供，请扫码增加活跃值'
                }
                return !util.openScan(title, msg)
              }
        }
        function openWin(name, url, id){
            api.openWin({
                name: name,
                url: url,
                bounces: false,
                animation: {
                  type: 'movein',
                  duration: 300
                },
                pageParam: {
                  id: id
                }
            })
        }
  },
  shareWebpage: function(params){
    var wx = api.require('wx')
        wx.shareWebpage({
            scene: params.scene || 'session',
            title: params.title || '汇医培',
            description: params.description || '',
            thumb: params.picture,
            contentUrl: params.contentUrl || 'http://h.maissy.net/doctor/#/index'
        }, function(ret, err) {
            // ret && api.toast({msg: '分享成功', location: 'middle'})
        })
  },
  actionMenu: function(params){
    var dialogBox = api.require('dialogBox')
    dialogBox.actionMenu({
        rect:{
            h: 150
        },
        texts:{
             cancel: '取消'
        },
        items:[
        {
            text: '微信好友',
            icon: 'widget://image/aui/share/wx.png'
        },
        {
            text: '朋友圈',
            icon: 'widget://image/aui/share/wx-circle.png'
        },
        {
            text: '复制链接',
            icon: 'widget://image/common/icon-clone.png'
        }
        ],
        isCuttingLine: true,
        tapClose: true,
        styles:{
            bg:'#FFF',
            column: 3,
            itemText: {
                color: '#000',
                size: 12,
                marginT: 5
            },
            itemIcon:{
                size: 60
            },
            cancel:{
                color:'#000',
                h: 44 ,
                size: 16
            }
        }
    }, function(ret){
        dialogBox.close({dialogName: 'actionMenu'})
        if(ret.eventType === 'cancel'){
        }else{
          switch (ret.index) {//分享给好友
            case 0:
              openWx('session')
              break
            case 1://分享到朋友圈
              openWx('timeline')
              break;
            case 2:
                var clipBoard = api.require('clipBoard')
                    clipBoard.set({
                      value: 'h.maissy.net/doctor/#/article/details/' + api.pageParam.id
                    }, function(ret, err) {
                      ret ? api.toast({msg: '复制成功',location: 'middle'}) : api.toast({msg: '复制失败', location: 'middle'})
                    })
              break
            default:
          }
        }
    })

    function openWx(scene){
      api.download({
           url: api.pageParam.picture + '-32k'
        },function(ret){
          var picture = ''
          if(ret && ret.fileSize <= 32000){
            picture = ret.savePath
          }else{
            picture = 'widget://image/common/logo.png'
          }
          util.shareWebpage({
            scene: scene,
            title: api.pageParam.title,
            description: api.pageParam.description,
            picture: picture,
            contentUrl: 'h.maissy.net/doctor/#/article/details/' + api.pageParam.id
          })
        })
    }
  }
}
